namespace Programming_CSharp
{
	using System;
	using System.Collections;

	// ܼȭ ListBox Ʈ 
	public class ListBoxTest : IEnumerable
	{
		//  ListBoxEnumerator
		private class ListBoxEnumerator : IEnumerator
		{
			//  Ŭ ȿ ִ ̹Ƿ 
			// ListBoxTest ȿ ̴.
			public ListBoxEnumerator(ListBoxTest lbt)
			{
				this.lbt = lbt;
				index = -1;
			}

			//  Ű, 
			//  ȿ ȮѴ.
			public bool MoveNext()
			{
				index++;
				if (index >= lbt.strings.Length)
					return false;
				else
					return true;
			}

			public void Reset()
			{
				index = -1;
			}

			// Current Ƽ  ڿ 
			// Ʈ ڽ ߰ǵ ǵǾ.
			public object Current
			{
				get
				{
					return(lbt[index]);
				}
			}

			private ListBoxTest lbt;
			private int index;
		}

		//   Ŭ ڸ ȯ  ִ.
		public IEnumerator GetEnumerator()
		{
			return (IEnumerator) new ListBoxEnumerator(this);
		}

		// ڿ Ͽ Ʈ ڽ ʱȭѴ. 
		public ListBoxTest(params string[] initialStrings)
		{
			// strings   ҴѴ.
			strings = new String[8]; 

			// ڷ ޵ strings Ѵ.
			foreach (string s in initialStrings)
			{
				strings[ctr++] = s;
			}
		}

		// Ʈ ڽ κп ڿ ϳ ߰Ѵ.
		public void Add(string theString)
		{
			strings[ctr] = theString;
			ctr++;
		}

		// 迭   ϵ 㰡Ѵ.
		public string this[int index]
		{
			get
			{
				if (index < 0 || index >= strings.Length)
				{
					// ߸  óѴ.
				}
				return strings[index];
			}
			set
			{
				strings[index] = value;
			}
		}
   
		//  ִ ڿ  ˷ ش. 
		public int GetNumEntries()
		{
			return ctr;
		}

		private string[] strings;
		private int ctr = 0;
	}

	public class Tester
	{
		static void Main()
		{
			// ο Ʈ ڽ ϰ ʱȭѴ.
			ListBoxTest lbt = 
			new ListBoxTest("Hello", "World");

			//   ڿ ߰Ѵ.
			lbt.Add("Who");
			lbt.Add("Is");
			lbt.Add("John");
			lbt.Add("Galt");

			//  ׽Ʈ 
			string subst = "Universe";
			lbt[1] = subst;

			//  ڿ Ѵ.
			foreach (string s in lbt)
			{
				Console.WriteLine("Value: {0}", s);
			}
		}
	}
}

