namespace Programming_CSharp
{
	using System;
	using System.Diagnostics;
	using System.Threading;

	public class MyMath
	{
		//  ̿  Ѵ. 
		public int DoSum(int n)
		{
			int result = 0;
			for(int i = 1; i <= n; i++)
			{
				result += i;
			}
			return result;
		}

		//   Ѵ. 
		public int DoSum2()
		{
			return 1+2+3+4+5+6+7+8+9+10+11
				+12+13+14+15+16+17+18+19+20;
		}

	}

	public class TestDriver
	{
		public static void Main()
		{

			const int val = 20;  // val  Ѵ. 

			// 鸸  ݺѴ.
			const int iterations = 1000000;

			//  Ѵ. 
			int result = 0;

			MyMath m = new MyMath();            

			//  ð   
			DateTime startTime = DateTime.Now;

			//   
			for (int i = 0;i < iterations;i++)
			{
				result = m.DoSum(val);
			}
        
			//  ð 
			TimeSpan elapsed = 
				DateTime.Now - startTime;

			//  
			Console.WriteLine(
				"Loop: Sum of ({0}) = {1}",
					val, result);
			Console.WriteLine(
				"The elapsed time in milliseconds is: " + 
				elapsed.TotalMilliseconds.ToString());

			// ο  ð 
			startTime = DateTime.Now;

			//  
			for (int i = 0;i < iterations;i++)
			{
				result = m.DoSum2();
			}

			// ο  ð  
			elapsed = DateTime.Now - startTime;

			//  
			Console.WriteLine(
				"Brute Force: Sum of ({0}) = {1}",
					val, result);
			Console.WriteLine(
				"The elapsed time in milliseconds is: " + 
				elapsed.TotalMilliseconds);
		}
	}
}

