namespace Programming_CSharp
{
	using System;

	public class StringTester
	{
		static void Main()
		{
			// ڿ Ѵ.
			string s1 = "abcd";
			string s2 = "ABCD";
			string s3 = @"Liberty Associates, Inc.
                 provides custom .NET development,
                 on-site Training and Consulting";
    
			int result;  //   Ѵ.

			//  ڿ Ѵ(ҹڸ ).
			result = string.Compare(s1, s2);
			Console.WriteLine(	
				"compare s1: {0}, s2: {1}, result: {2}\n", 
				s1, s2, result);            

			// ε Compare()
			// ҹڸ ϴ θ ϴ Ҹ ڸ Ѵ.
			// (true = ҹڸ  )
			result = string.Compare(s1,s2, true);
			Console.WriteLine("compare insensitive\n");
			Console.WriteLine("s4: {0}, s2: {1}, result: {2}\n", 
				s1, s2, result);            

			// ڿ ̾ ̴ ޼ҵ
			string s6 = string.Concat(s1,s2);
			Console.WriteLine(
				"s6 concatenated from s1 and s2: {0}", s6);

			// ε ڸ Ѵ.
			string s7 = s1 + s2;
			Console.WriteLine(
				"s7 concatenated from s1 + s2: {0}", s7);

			// ڿ ϴ ޼ҵ
			string s8 = string.Copy(s7);
			Console.WriteLine(
				"s8 copied from s7: {0}", s8);

			// ε ڸ Ѵ.
			string s9 = s8;
			Console.WriteLine("s9 = s8: {0}", s9);

			//    
			Console.WriteLine(
				"\nDoes s9.Equals(s8)?: {0}", 
				s9.Equals(s8));
			Console.WriteLine(   
				"Does Equals(s9,s8)?: {0}", 
				string.Equals(s9,s8));
			Console.WriteLine(
				"Does s9==s8?: {0}", s9 == s8);

			//  Ӽ: ΰ 
			Console.WriteLine(
				"\nString s9 is {0} characters long. ", 
				s9.Length);
			Console.WriteLine(
				"The 5th character is {1}\n", 
				s9.Length, s9[4]);

			// ڿ ־ ڵ  ˻Ѵ.
			Console.WriteLine("s3:{0}\nEnds with Training?: {1}\n",
				s3, 
				s3.EndsWith("Training") );
			Console.WriteLine(
				"Ends with Consulting?: {0}",
				s3.EndsWith("Consulting"));

			// κ ڿ  ȯѴ.
			Console.WriteLine(
				"\nThe first occurrence of Training ");
			Console.WriteLine ("in s3 is {0}\n", 
				s3.IndexOf("Training"));

			// training տ excellent Ѵ.
			string s10 = s3.Insert(103,"excellent ");
			Console.WriteLine("s10: {0}\n",s10);

			//    ĥ  ִ.
			string s11 = s3.Insert(s3.IndexOf("Training"),
				"excellent ");
			Console.WriteLine("s11: {0}\n",s11);
		}
	}
}

