namespace Programming_CSharp
{
	using System;
	using System.Threading;

	class Tester
	{
		static void Main()
		{
			// Tester Ŭ νϽ Ѵ.
			Tester t = new Tester();

			// ܺ Main Ѵ. 
			t.DoTest();                 
		}

		public void DoTest()
		{
			//  迭 Ѵ. 
			Thread[] myThreads = 
			{
				new Thread( new ThreadStart(Decrementer) ),
				new Thread( new ThreadStart(Incrementer) )              
			};

			//  带 Ѵ.
			int ctr = 1;
			foreach (Thread myThread in myThreads)
			{
				myThread.IsBackground=true;
				myThread.Start();
				myThread.Name = "Thread" + ctr.ToString();
				ctr++;
				Console.WriteLine("Started thread {0}", myThread.Name);
				Thread.Sleep(50);
			}

			//  尡   ٸ.
			foreach (Thread myThread in myThreads)
			{
				myThread.Join();
			}

			//  尡 Ǹ ޽ Ѵ.
			Console.WriteLine("All my threads are done.");
		}

		void Decrementer()
		{
			try 
			{
				// ⿡ ȭŲ. 
				Monitor.Enter(this);

				// counter 10 ƴ϶ 
				// ͸ ٸ  尡 ϵ ݳϰ,
				//  带 ϰ Ѵ. 
				if (counter < 10)
				{
					Console.WriteLine(
						"[{0}] In Decrementer. Counter: {1}. Gotta Wait!",
						Thread.CurrentThread.Name, counter);
					Monitor.Wait(this);
				}

				while (counter >0)
				{
					long temp = counter;
					temp--;
					Thread.Sleep(1);
					counter = temp;
					Console.WriteLine(
						"[{0}] In Decrementer. Counter: {1}. ",
						Thread.CurrentThread.Name, counter);

				}
			}
			finally
			{
				Monitor.Exit(this);
			}
		}

		void Incrementer()
		{
			try
			{
				Monitor.Enter(this);
				while (counter < 10)
				{
					long temp = counter;
					temp++;
					Thread.Sleep(1);
					counter = temp;
					Console.WriteLine(
						"[{0}] In Incrementer. Counter: {1}",
						Thread.CurrentThread.Name, counter);
				}

				//  Ƿ 
				// ٸ 尡 ͸ ϵ Ѵ. 
				Monitor.Pulse(this);
			}
			finally
			{
				Console.WriteLine("[{0}] Exiting...",
					Thread.CurrentThread.Name);
				Monitor.Exit(this);
			}
		}
		private long counter = 0;
	}
}

