using System;
using System.Net.Sockets;
using System.Text;
using System.IO;

// Ŭ̾Ʈκ  ̸ ޴´.
//      Ŭ̾Ʈ Ѵ.
public class AsynchNetworkFileServer
{
  
	class ClientHandler
	{
		// 
		public ClientHandler( 
			Socket socketForClient )
		{
			//   ʱȭѴ.
			socket = socketForClient;

			//   ϱ  ۸ ʱȭѴ.
			buffer = new byte[256];

			// Ʈũ Ʈ Ѵ.
			networkStream = 
				new NetworkStream(socketForClient);

			//  б  ݹ Ѵ.
			myFileCallBack = 
				new AsyncCallback(this.OnFileCompletedRead);

			// Ʈũ Ʈκ б  ݹ Ѵ. 
			callbackRead =
				new AsyncCallback(this.OnReadComplete);

			// Ʈũ Ʈ   ݹ Ѵ.
			callbackWrite =
				new AsyncCallback(this.OnWriteComplete);
		}

		// Ŭ̾Ʈ ڿ б Ѵ.
		public void StartRead(  )
		{
			// Ʈũκ д´.
			//  ̸ ´.
			networkStream.BeginRead(
				buffer, 0, buffer.Length, 
				callbackRead, null);
		}

		//  бⰡ , ڿ ȭ鿡 ϰ
		// ٽ Ŭ̾Ʈ  Ѵ.
		private void OnReadComplete( IAsyncResult ar )
		{
			int bytesRead = networkStream.EndRead(ar);

			//  ڿ ִ 
			if( bytesRead > 0 )
			{
				// ۷κ  ̸ ´.
				string fileName = 
					System.Text.Encoding.ASCII.GetString(
					buffer, 0, bytesRead);

				// ֿܼ  ̸ Ѵ.
				Console.Write( 
					"Opening file {0}", fileName);

				//  Է Ʈ .
				inputStream = 
					File.OpenRead(fileName);

				//  б Ѵ.
				inputStream.BeginRead(
					buffer,             //  Ѵ.
					0,                  // 
					buffer.Length,      //  ũ
					myFileCallBack,     // ݹ 
					null);              //   ü

			}
			else
			{
				Console.WriteLine( "Read connection dropped");
				networkStream.Close();
				socket.Close();
				networkStream = null;
				socket = null;
			}
		}

		//  д ۰  
		void OnFileCompletedRead(IAsyncResult asyncResult)
		{
			int bytesRead = 
				inputStream.EndRead(asyncResult);

			// о    ִ 
			if (bytesRead > 0)
			{
				// Ŭ̾Ʈ Ѵ.
				networkStream.BeginWrite(
					buffer, 0, bytesRead, callbackWrite, null);
			}
		}


		// ڿ   ٸ  д´.
		private void OnWriteComplete( IAsyncResult ar )
		{
			networkStream.EndWrite(ar);
			Console.WriteLine( "Write complete");

			// ٸ  б Ѵ.
			inputStream.BeginRead(
				buffer,             //  Ѵ.
				0,                  // 
				buffer.Length,      //  ũ
				myFileCallBack,         // ݹ 
				null);              //   ü

		}

		private const int       BufferSize = 256;
		private byte[]          buffer;
		private Socket          socket;
		private NetworkStream   networkStream;
		private Stream          inputStream;
		private AsyncCallback   callbackRead;
		private AsyncCallback   callbackWrite;
		private AsyncCallback   myFileCallBack; 


	}


	public static void Main()
	{
		AsynchNetworkFileServer app = 
			new AsynchNetworkFileServer();
		app.Run();
	}

	private void Run()
	{
		// ο tcpListener ϰ Ѵ.
		// (65000 Ʈ )
		TcpListener tcpListener = new TcpListener(65000);
		tcpListener.Start();       

		//    Ŭ̾Ʈ   ٸ.
		for (;;)
		{
			// Ŭ̾Ʈ ϸ, 
			// socketForClient ̸  ȯѴ.
			// tcpListener ؼ  ٸ.
			Socket socketForClient = 
				tcpListener.AcceptSocket();
			if (socketForClient.Connected)
			{
				Console.WriteLine("Client connected");
				ClientHandler handler = 
					new ClientHandler(socketForClient);
				handler.StartRead();
			}
		}
	}
}
